package anywheresoftware.b4a.samples.tabhost;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "anywheresoftware.b4a.samples.tabhost", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "anywheresoftware.b4a.samples.tabhost", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.TabHostWrapper _tabhost1 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtname = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtanimal = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtcolor = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp1 = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp2 = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp3 = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp4 = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp5 = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp6 = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp7 = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp8 = null;
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 10;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(512);
 BA.debugLineNum = 11;BA.debugLine="Activity.LoadLayout(\"main\")";
Debug.ShouldStop(1024);
mostCurrent._activity.LoadLayout("main",mostCurrent.activityBA);
 BA.debugLineNum = 12;BA.debugLine="Dim bmp1, bmp2, bmp3, bmp4, bmp5, bmp6, bmp7, bmp8 As Bitmap";
Debug.ShouldStop(2048);
_bmp1 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();Debug.locals.put("bmp1", _bmp1);
_bmp2 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();Debug.locals.put("bmp2", _bmp2);
_bmp3 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();Debug.locals.put("bmp3", _bmp3);
_bmp4 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();Debug.locals.put("bmp4", _bmp4);
_bmp5 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();Debug.locals.put("bmp5", _bmp5);
_bmp6 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();Debug.locals.put("bmp6", _bmp6);
_bmp7 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();Debug.locals.put("bmp7", _bmp7);
_bmp8 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();Debug.locals.put("bmp8", _bmp8);
 BA.debugLineNum = 13;BA.debugLine="bmp1 = LoadBitmap(File.DirAssets, \"ic.png\")";
Debug.ShouldStop(4096);
_bmp1 = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"ic.png");Debug.locals.put("bmp1", _bmp1);
 BA.debugLineNum = 14;BA.debugLine="bmp2 = LoadBitmap(File.DirAssets, \"ic_selected.png\")";
Debug.ShouldStop(8192);
_bmp2 = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"ic_selected.png");Debug.locals.put("bmp2", _bmp2);
 BA.debugLineNum = 15;BA.debugLine="bmp1 = LoadBitmap(File.DirAssets, \"all.png\")";
Debug.ShouldStop(16384);
_bmp1 = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"all.png");Debug.locals.put("bmp1", _bmp1);
 BA.debugLineNum = 16;BA.debugLine="bmp2 = LoadBitmap(File.DirAssets, \"ic_selected.png\")";
Debug.ShouldStop(32768);
_bmp2 = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"ic_selected.png");Debug.locals.put("bmp2", _bmp2);
 BA.debugLineNum = 17;BA.debugLine="bmp3 = LoadBitmap(File.DirAssets, \"champ.png\")";
Debug.ShouldStop(65536);
_bmp3 = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"champ.png");Debug.locals.put("bmp3", _bmp3);
 BA.debugLineNum = 18;BA.debugLine="bmp4 = LoadBitmap(File.DirAssets, \"champ.png\")";
Debug.ShouldStop(131072);
_bmp4 = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"champ.png");Debug.locals.put("bmp4", _bmp4);
 BA.debugLineNum = 19;BA.debugLine="bmp5 = LoadBitmap(File.DirAssets, \"fav.png\")";
Debug.ShouldStop(262144);
_bmp5 = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"fav.png");Debug.locals.put("bmp5", _bmp5);
 BA.debugLineNum = 20;BA.debugLine="bmp6 = LoadBitmap(File.DirAssets, \"fav.png\")";
Debug.ShouldStop(524288);
_bmp6 = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"fav.png");Debug.locals.put("bmp6", _bmp6);
 BA.debugLineNum = 21;BA.debugLine="bmp7 = LoadBitmap(File.DirAssets, \"settings.png\")";
Debug.ShouldStop(1048576);
_bmp7 = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"settings.png");Debug.locals.put("bmp7", _bmp7);
 BA.debugLineNum = 22;BA.debugLine="bmp8 = LoadBitmap(File.DirAssets, \"settings.png\")";
Debug.ShouldStop(2097152);
_bmp8 = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"settings.png");Debug.locals.put("bmp8", _bmp8);
 BA.debugLineNum = 25;BA.debugLine="TabHost1.AddTabWithIcon (\"All\", bmp1, bmp2, \"page1\") 'load the layout file of each page";
Debug.ShouldStop(16777216);
mostCurrent._tabhost1.AddTabWithIcon(mostCurrent.activityBA,"All",(android.graphics.Bitmap)(_bmp1.getObject()),(android.graphics.Bitmap)(_bmp2.getObject()),"page1");
 BA.debugLineNum = 26;BA.debugLine="TabHost1.AddTabWithIcon(\"Championship\", bmp3, bmp4, \"page2\")";
Debug.ShouldStop(33554432);
mostCurrent._tabhost1.AddTabWithIcon(mostCurrent.activityBA,"Championship",(android.graphics.Bitmap)(_bmp3.getObject()),(android.graphics.Bitmap)(_bmp4.getObject()),"page2");
 BA.debugLineNum = 27;BA.debugLine="TabHost1.AddTabWithIcon(\"Favourites\", bmp5, bmp6, \"page3\")";
Debug.ShouldStop(67108864);
mostCurrent._tabhost1.AddTabWithIcon(mostCurrent.activityBA,"Favourites",(android.graphics.Bitmap)(_bmp5.getObject()),(android.graphics.Bitmap)(_bmp6.getObject()),"page3");
 BA.debugLineNum = 28;BA.debugLine="TabHost1.AddTabWithIcon(\"Options\", bmp7, bmp8, \"page4\")";
Debug.ShouldStop(134217728);
mostCurrent._tabhost1.AddTabWithIcon(mostCurrent.activityBA,"Options",(android.graphics.Bitmap)(_bmp7.getObject()),(android.graphics.Bitmap)(_bmp8.getObject()),"page4");
 BA.debugLineNum = 29;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _finishing) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Finishing", _finishing);
 BA.debugLineNum = 30;BA.debugLine="Sub Activity_Pause (Finishing As Boolean)";
Debug.ShouldStop(536870912);
 BA.debugLineNum = 32;BA.debugLine="End Sub";
Debug.ShouldStop(-2147483648);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 33;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(1);
 BA.debugLineNum = 35;BA.debugLine="End Sub";
Debug.ShouldStop(4);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btndone_click() throws Exception{
		Debug.PushSubsStack("btnDone_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.keywords.StringBuilderWrapper _sb = null;
 BA.debugLineNum = 44;BA.debugLine="Sub btnDone_Click";
Debug.ShouldStop(2048);
 BA.debugLineNum = 45;BA.debugLine="Dim sb As StringBuilder";
Debug.ShouldStop(4096);
_sb = new anywheresoftware.b4a.keywords.StringBuilderWrapper();Debug.locals.put("sb", _sb);
 BA.debugLineNum = 46;BA.debugLine="sb.Initialize";
Debug.ShouldStop(8192);
_sb.Initialize();
 BA.debugLineNum = 47;BA.debugLine="sb.Append(\"You have entered:\").Append(CRLF)";
Debug.ShouldStop(16384);
_sb.Append("You have entered:").Append(anywheresoftware.b4a.keywords.Common.CRLF);
 BA.debugLineNum = 48;BA.debugLine="sb.Append(\"Name: \").Append(txtName.Text).Append(CRLF)";
Debug.ShouldStop(32768);
_sb.Append("Name: ").Append(mostCurrent._txtname.getText()).Append(anywheresoftware.b4a.keywords.Common.CRLF);
 BA.debugLineNum = 49;BA.debugLine="sb.Append(\"Color: \").Append(txtColor.Text).Append(CRLF)";
Debug.ShouldStop(65536);
_sb.Append("Color: ").Append(mostCurrent._txtcolor.getText()).Append(anywheresoftware.b4a.keywords.Common.CRLF);
 BA.debugLineNum = 50;BA.debugLine="sb.Append(\"Animal: \").Append(txtAnimal.Text)";
Debug.ShouldStop(131072);
_sb.Append("Animal: ").Append(mostCurrent._txtanimal.getText());
 BA.debugLineNum = 51;BA.debugLine="Msgbox(sb.ToString, \"\")";
Debug.ShouldStop(262144);
anywheresoftware.b4a.keywords.Common.Msgbox(_sb.ToString(),"",mostCurrent.activityBA);
 BA.debugLineNum = 52;BA.debugLine="End Sub";
Debug.ShouldStop(524288);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnnext1_click() throws Exception{
		Debug.PushSubsStack("btnNext1_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 36;BA.debugLine="Sub btnNext1_Click";
Debug.ShouldStop(8);
 BA.debugLineNum = 37;BA.debugLine="TabHost1.CurrentTab = 1 'move to next tab";
Debug.ShouldStop(16);
mostCurrent._tabhost1.setCurrentTab((int)(1));
 BA.debugLineNum = 38;BA.debugLine="End Sub";
Debug.ShouldStop(32);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnnext2_click() throws Exception{
		Debug.PushSubsStack("btnNext2_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 40;BA.debugLine="Sub btnNext2_Click";
Debug.ShouldStop(128);
 BA.debugLineNum = 41;BA.debugLine="TabHost1.CurrentTab = 2 'move to next tab";
Debug.ShouldStop(256);
mostCurrent._tabhost1.setCurrentTab((int)(2));
 BA.debugLineNum = 42;BA.debugLine="End Sub";
Debug.ShouldStop(512);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
                if (mostCurrent != null) {
Debug.StartDebugging(mostCurrent.activityBA, 33473, new int[] {2} );}

		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 BA.debugLineNum = 5;BA.debugLine="Sub Globals";
 BA.debugLineNum = 6;BA.debugLine="Dim TabHost1 As TabHost";
mostCurrent._tabhost1 = new anywheresoftware.b4a.objects.TabHostWrapper();
 BA.debugLineNum = 7;BA.debugLine="Dim txtName, txtAnimal, txtColor As EditText";
mostCurrent._txtname = new anywheresoftware.b4a.objects.EditTextWrapper();
mostCurrent._txtanimal = new anywheresoftware.b4a.objects.EditTextWrapper();
mostCurrent._txtcolor = new anywheresoftware.b4a.objects.EditTextWrapper();
 BA.debugLineNum = 8;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 BA.debugLineNum = 1;BA.debugLine="Sub Process_Globals";
 BA.debugLineNum = 3;BA.debugLine="End Sub";
return "";
}
public static String  _tabhost1_tabchanged() throws Exception{
		Debug.PushSubsStack("TabHost1_TabChanged (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 54;BA.debugLine="Sub TabHost1_TabChanged";
Debug.ShouldStop(2097152);
 BA.debugLineNum = 55;BA.debugLine="Activity.Title = \"Current Tab = \" & TabHost1.CurrentTab";
Debug.ShouldStop(4194304);
mostCurrent._activity.setTitle((Object)("Current Tab = "+BA.NumberToString(mostCurrent._tabhost1.getCurrentTab())));
 BA.debugLineNum = 56;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"TabHost1",_tabhost1,"txtName",_txtname,"txtAnimal",_txtanimal,"txtColor",_txtcolor};
}
}
